#!/bin/sh

modulecc=`cc -v 2>&1 | tail -1`

version="^Linux version [^(]* ([^()]*@[^()]*) (\(.*\)) .*"
kernelcc=`cat /proc/version | sed "s/$version/\1/"`
 
modulecc=`echo $modulecc | cut -d ' ' -f 3 | sed 's/\([0-9]\.[0-9]*\)\..*/\1/'`
kernelcc=`echo $kernelcc | cut -d ' ' -f 3 | sed 's/\([0-9]\.[0-9]*\)\..*/\1/'`

if [ -z $CROSS ]; then 
   if [ -z $IGNORE_CC_MISMATCH ]; then 
        if [ $kernelcc != $modulecc ]; then 
                echo "                                                            "; 
                echo "You appear to be compiling the REALmagic kernel module with ";
                echo "a compiler different from the one that was used to compile  ";
                echo "the running kernel.                                         ";
                echo "current gcc version :  $modulecc                            ";
                echo "kernel  gcc version :  $kernelcc                            ";
                echo -en "\033[1;31m"; 
                echo -e  "*** Failed gcc sanity check. ***"; 
                echo -en "\033[0m"; 
        exit -1; 
        fi 
   fi
fi
