/*****************************************
 Copyright  2004-2005
 Sigma Designs, Inc. All Rights Reserved
 Proprietary and Confidential
 *****************************************/
/**
  @file   rmem86xxid.h
  @brief  

  long description

  @author Emmanuel Michon
  @date   2004-09-22
*/

#ifndef __RMEM86XXID_H__
#define __RMEM86XXID_H__

/*
  the main chip ids 
  
  tango3 is for asic development (should be tango\infty)

  Usually, users do not set by hand, but thru `rmcflags' helper
*/
#define EM86XX_CHIPID_MAMBO      1000
#define EM86XX_CHIPID_MAMBOLIGHT 2000
#define EM86XX_CHIPID_TANGO      3000
#define EM86XX_CHIPID_TANGOLIGHT 4000
#define EM86XX_CHIPID_TANGO15    4500
#define EM86XX_CHIPID_TANGO2     5000
#define EM86XX_CHIPID_TANGO3    10000

#if (EM86XX_CHIP==EM86XX_CHIPID_MAMBO)
#define S_EM86XX_CHIPID "mambo"
#elif (EM86XX_CHIP==EM86XX_CHIPID_MAMBOLIGHT)
#define S_EM86XX_CHIPID "mambolight"
#elif (EM86XX_CHIP==EM86XX_CHIPID_TANGOLIGHT)
#define S_EM86XX_CHIPID "tangolight"
#elif (EM86XX_CHIP==EM86XX_CHIPID_TANGO15)
#define S_EM86XX_CHIPID "tango15"
#elif (EM86XX_CHIP==EM86XX_CHIPID_TANGO2)
#define S_EM86XX_CHIPID "tango2"
#elif (EM86XX_CHIP==EM86XX_CHIPID_TANGO3)
#define S_EM86XX_CHIPID "tango3"
#else
#error EM86XX_CHIP is not set
#endif

/* 
  revisions...
  
  Referring to whatever is written at the surface of the BGA,
  not the PCI revid / subid / etc. This detail is important for some chips
  are ambiguous software wise.
  
  1: ES1
  2: ES2
  3: ES3
  4: ES4 
  65: revA
  66: revB
  67: revC
  
  No ID, but numbers. For a 8630ES2 for instance: build with
  RMCFLAGS="... -DEM86XX_CHIP=EM86XX_CHIPID_TANGO2 -DEM86XX_REVISION=2 ..."
  
  Usually, users do not set by hand, but thru `rmcflags' helper
*/
#ifndef EM86XX_REVISION
#error EM86XX_REVISION is not set
#endif

#if (EM86XX_REVISION==1)
#define S_EM86XX_REVISION "ES1"
#elif (EM86XX_REVISION==2)
#define S_EM86XX_REVISION "ES2"
#elif (EM86XX_REVISION==3)
#define S_EM86XX_REVISION "ES3"
#elif (EM86XX_REVISION==4)
#define S_EM86XX_REVISION "ES4"
#elif (EM86XX_REVISION=='A')
#define S_EM86XX_REVISION "revA"
#elif (EM86XX_REVISION=='B')
#define S_EM86XX_REVISION "revB"
#elif (EM86XX_REVISION=='C')
#define S_EM86XX_REVISION "revC"
#else
#error complete revision strings
#endif

/* the compilation modes */
#define EM86XX_MODEID_WITHHOST   1000
#define EM86XX_MODEID_STANDALONE 2000

/* the dsps */
#define EM86XX_ENGINEID_MPEG0 10
#define EM86XX_ENGINEID_MPEG1 11
#define EM86XX_ENGINEID_AUDIO0 20
#define EM86XX_ENGINEID_AUDIO1 21
#define EM86XX_ENGINEID_DEMUX 30

/* the microcode debug mode */

#define EM86XX_DEBUG_CHIP	1000
#define EM86XX_DEBUG_SIMU	2000

#endif // __RMEM86XXID_H__
