 /*****************************************
 Copyright  2001-2003  
 Sigma Designs, Inc. All Rights Reserved
 Proprietary and Confidential
 *****************************************/
/**
  @file   rmendian.h
  @brief  

  @author Emmanuel Michon
  @date   2002-11-05
*/

//   This is the standard way to probe for endianness:
//
//   #if (RMENDIANNESS==RMLITTLEENDIAN)
//   // do for little endian
//   #elif (RMENDIANNESS==RMBIGENDIAN)
//   // do for big endian
//   #else
//   // others not handled
//   NOTCOMPILABLE
//   #endif 

#ifndef __RMENDIAN_H__
#define __RMENDIAN_H__

#define RMLITTLEENDIAN 4321
#define RMBIGENDIAN 1234

#if (RMCOMPILERID==RMCOMPILERID_GCC)

// gcc on sparc reports little endian??? what is this??? works on i386 anyways. hackEmmanuel
#if (__BYTE_ORDER==__LITTLE_ENDIAN)
#define RMENDIANNESS RMLITTLEENDIAN
#elif (__BYTE_ORDER==__BIG_ENDIAN)
#define RMENDIANNESS RMBIGENDIAN
#else
NOTCOMPILABLE
#endif

#elif (RMCOMPILERID==RMCOMPILERID_ARMELF_GCC)

#define RMENDIANNESS RMLITTLEENDIAN

#elif (RMCOMPILERID==RMCOMPILERID_SPARC_GCC)

#define RMENDIANNESS RMBIGENDIAN

#elif (RMCOMPILERID==RMCOMPILERID_PPC_GCC)

#define RMENDIANNESS RMBIGENDIAN

#elif (RMCOMPILERID==RMCOMPILERID_VISUALC)

// real test is not implemented! Will fail on big endian win32 visual platforms! hackEmmanuel
#define RMENDIANNESS RMLITTLEENDIAN

#else

NOTCOMPILABLE

#endif 

#endif // __RMENDIAN_H__
