//@{
/** no error */
RM_DEFINE_ERROR(OK)
//@}

//@{
/** no error, but action is still pending */
RM_DEFINE_ERROR(PENDING)
/** used in case of synchronous transfer */
RM_DEFINE_ERROR(XFER_DONE)
//@}

//@{
// generic errors 
RM_DEFINE_ERROR(ERROR)
RM_DEFINE_ERROR(FATAL)
RM_DEFINE_ERROR(NOTIMPLEMENTED)
/** if a set-only property is used in get mode for instance */
RM_DEFINE_ERROR(INVALIDMODE)
RM_DEFINE_ERROR(DEPRECATED)
RM_DEFINE_ERROR(PARAMETER_OUT_OF_RANGE)
RM_DEFINE_ERROR(INVALID_PARAMETER)
RM_DEFINE_ERROR(ACCESS_VIOLATION)
RM_DEFINE_ERROR(INSUFFICIENT_SIZE)
RM_DEFINE_ERROR(NOT_FOUND)
RM_DEFINE_ERROR(NOT_SUPPORTED)
//@}

//@{
/** conceptual errors : no such interface */
RM_DEFINE_ERROR(ERRORNOSUCHINTERFACE)
/** conceptual errors : interface with no owner */
RM_DEFINE_ERROR(ERRORINTERFACEWITHNOOWNER)
//@}

//@{
/** instance creation error */
RM_DEFINE_ERROR(ERRORCREATEINSTANCE)
//@}

//@{
/** other libc errors : out of file descriptors */
RM_DEFINE_ERROR(ERROROUTOFFILEDESCRIPTORS)
/** other libc errors : catching too many  ``interrupted system call'' (Linux)*/
RM_DEFINE_ERROR(ERROREINTR) // catching too much ``interrupted system call'' (Linux)
//@}

//@{
/** Events errors : fatal event error*/
RM_DEFINE_ERROR(FATALEVENT)
//@}

//@{
/** Semaphores errors : fatal semaphore error*/
RM_DEFINE_ERROR(FATALSEMAPHORE)
RM_DEFINE_ERROR(SEMAPHORELOCKED)
//@}

//@{
/** Semaphores errors : fatal semaphore error*/
RM_DEFINE_ERROR(FATAL_TOS)
RM_DEFINE_ERROR(TOS_TIMEOUT)
RM_DEFINE_ERROR(TOS_EVENT)
RM_DEFINE_ERROR(TOS_ERROR)
//@}

//@{
/** Critical Sections errors : fatal critical section error*/
RM_DEFINE_ERROR(FATALCRITSEC)
/** Critical Sections errors : inconsistent critical section call*/
RM_DEFINE_ERROR(FATALINCONSISTENTCRITICALSECTIONCALL)
//@}

//@{
/** Condition Variable errors */
RM_DEFINE_ERROR(FATALCONDVAR)
//@}

//@{ 
/** Threads errors : create thread error */
RM_DEFINE_ERROR(FATALCREATETHREAD)
/** Threads errors : thread table overflow */
RM_DEFINE_ERROR(FATALTHREADTABLEOVERFLOW)
//@}

//@{
/** Memory manager errors : given buffer is so small we can't even create the empty layout */
RM_DEFINE_ERROR(FATALBUFFERTOOSMALL)
/** Memory manager errors : malloc with zero size */
RM_DEFINE_ERROR(FATALASKEDZEROSIZEMALLOC)
/** Memory manager errors : invalid pointer*/
RM_DEFINE_ERROR(FATALINVALIDPOINTER)
/** Memory manager errors : memory has been corrupted*/
RM_DEFINE_ERROR(FATALMEMORYCORRUPTED)
/** Memory manager errors : out of memory*/
RM_DEFINE_ERROR(FATALOUTOFMEMORY)
/** Memory manager errors : memory is not free*/
RM_DEFINE_ERROR(ERRORMEMORYISNOTFREE)
//@}

//@{
/** pool object errors */
RM_DEFINE_ERROR(INVALID_NEW)
RM_DEFINE_ERROR(INVALID_DELETE)
//@}

//@{
/** I/O errors : cannot open file*/
RM_DEFINE_ERROR(ERROROPENFILE)
/** I/O errors : cannot close file*/
RM_DEFINE_ERROR(ERRORCLOSEFILE)
/** I/O errors : cannot write file*/
RM_DEFINE_ERROR(ERRORWRITEFILE)
/** I/O errors : cannot read file*/
RM_DEFINE_ERROR(ERRORREADFILE)
/** I/O errors : cannot seek in the file*/
RM_DEFINE_ERROR(ERRORSEEKFILE)
/** I/O errors : end of file*/
RM_DEFINE_ERROR(ERRORENDOFFILE)
/** I/O errors : file is locked*/
RM_DEFINE_ERROR(ERRORFILELOCKED)
/** I/O errors : no directory entry*/
RM_DEFINE_ERROR(ERRORNODIRECTORYENTRY)
//@}

//@{
/** dynamic loader errors -- they are recoverable. */
/** dynamic loader errors : cannot open shared library */
RM_DEFINE_ERROR(ERRORDYNAMICLIBOPEN)
/** dynamic loader errors : cannot get symbol from shared library */
RM_DEFINE_ERROR(ERRORDYNAMICLIBGETSYMBOL)
/** dynamic loader errors : cannot close shared library */
RM_DEFINE_ERROR(ERRORDYNAMICLIBCLOSE)
//@}

//@{
/** corelist errors : corelist not valid */
RM_DEFINE_ERROR(FATALCORELISTNOTVALID)
//@}

//@{
/** corequeue errors : corequeue not valid */
RM_DEFINE_ERROR(FATALCOREQUEUENOTVALID)
//@}

//@{
/** corepool errors : corepool not valid */
RM_DEFINE_ERROR(FATALCOREPOOLNOTVALID)
RM_DEFINE_ERROR(FATALCOREPOOLLEAKS)
RM_DEFINE_ERROR(FATALCOREPOOLRETURNEDTWICE)
RM_DEFINE_ERROR(FATALCOREPOOLISNOTMINE)
RM_DEFINE_ERROR(FATALCOREPOOLOVERFLOW)
//@}

//@{
/** queue errors : queue not valid */
RM_DEFINE_ERROR(FATALQUEUENOTVALID)
//@}

//@{
/** list errors : list not valid */
RM_DEFINE_ERROR(FATALLISTNOTVALID)
RM_DEFINE_ERROR(LISTISEMPTY)
//@}

//@{
/** packet command css errors. */
RM_DEFINE_ERROR(ERROR_KEYISNOTPRESENT)
//@}

//@{
/** graph errors : no graph in driver */
RM_DEFINE_ERROR(ERRORNOGRAPHINDRIVER)
/** graph errors : graph is full */
RM_DEFINE_ERROR(ERRORGRAPHFULL)
/** graph errors : graph can't be built */
RM_DEFINE_ERROR(ERRORGRAPHMISSINGNODEORMODULE)
/** wrong url: */
RM_DEFINE_ERROR(INVALID_URL)
/** wrong url prefix or cannot find xml description */
RM_DEFINE_ERROR(UNKNOWN_URL_PREFIX)
/** wrong input control or more than 1 input control*/
RM_DEFINE_ERROR(FATAL_INPUT_CONTROL)
//@}

//@{
/** object errors : object has been deleted */
RM_DEFINE_ERROR(OBJECTDELETED)
//@}

//@{
RM_DEFINE_ERROR(ERRORHARDWARELIBRARY)
//@}

//@{
RM_DEFINE_ERROR(VIDEOHASPAUSED)
RM_DEFINE_ERROR(ASPECTRATIOCHANGE)
RM_DEFINE_ERROR(ACMODECHANGE)
RM_DEFINE_ERROR(FETCHCC)
RM_DEFINE_ERROR(FETCHDTVCC)
RM_DEFINE_ERROR(FATALHARDWAREABSTRACTIONLAYER)
//@}

//@{
/** demux node error */
RM_DEFINE_ERROR(DEMUX_CANNOT_DETECT_AUDIO)
//@}


//@{
// socket errors
/** socket errors : socket init has failed */
RM_DEFINE_ERROR(ERRORSOCKETINITFAILED)
/** socket errors : incorrect version of the socket library */
RM_DEFINE_ERROR(ERRORSOCKETWRONGVERSION)
/** socket errors : fatal socket error */
RM_DEFINE_ERROR(FATALSOCKET)
//@}

//@{
// string errors
/** string errors : fatal string error */
RM_DEFINE_ERROR(FATALSTRING)
//@}

//@{
// AAc decoder errors.
/** AAC decoder errors : buffer too small to decode */
RM_DEFINE_ERROR(BUFFERTOOSMALL)
//@}

//@{
// udp errors
/** UDP socket errors : fatal UDP socket error */
RM_DEFINE_ERROR(FATALUDP)
//@}

//@{
// MP4 errors
/** MP4 errors : not an MP4 file */
RM_DEFINE_ERROR(ERROR_NOT_MP4)
RM_DEFINE_ERROR(MPEG4EOF)
//@}

//@{
// DIVX errors
/** DIVX errors : not an DIVX file */
RM_DEFINE_ERROR(ERROR_NOT_DIVX)
//@}

//@{
/** need more data to decode/parse something. */
RM_DEFINE_ERROR(NEED_MORE_DATA)
//@}

//@{
/** can't rewind stream. for mp3 decoder */
RM_DEFINE_ERROR(CANT_REWIND_STREAM)
RM_DEFINE_ERROR(MP3_DECODE_NOTHING)
RM_DEFINE_ERROR(MP3_INCOMPLETE_FRAME) // For inocmplete frame decoded in player
//@}

//@{
/** shift storage error */
RM_DEFINE_ERROR(SHIFTSTORAGE_FATAL)
//@}

//@{
// RMHWACCESS errors
/** something goes wrong with RMhwAccess */
RM_DEFINE_ERROR(HWACCESS_GENERIC_ERROR)
/** Hardware library version mismatch */
RM_DEFINE_ERROR(HWACCESS_HWLIB_VERSION_MISMATCH)
//@}

//@{
// RMSOCKET errors
/** something goes wrong with RMsocket */
RM_DEFINE_ERROR(CANT_OPEN_SOCKET)
//@}

//@{
// RMREMOTE errors
/** something goes wrong with RMremote */
RM_DEFINE_ERROR(ERROR_REMOTE)
//@}

//@{
// Properties errors
RM_DEFINE_ERROR(INVALID_PROPERTY_MAINSET)
RM_DEFINE_ERROR(INVALID_PROPERTY_SUBSET)
RM_DEFINE_ERROR(INVALID_PROPERTY_ID)
RM_DEFINE_ERROR(PROPERTY_NOT_SUPPORTED)
RM_DEFINE_ERROR(PROPERTY_NOT_SET)
//@}

//@{
/** no error, but the samples sent to the decoder contains no video data */
RM_DEFINE_ERROR(OK_HAS_NO_VIDEO)
/** Did not complete reading data from device. Try again later. */
RM_DEFINE_ERROR(ERROR_NOT_FINISHED)
/** Error reading data from device. Trying to recover. Not Fatal but bad. */
RM_DEFINE_ERROR(ERROR_INVALID_SECTORS)
/** Error reading data from device. Cannot recover. Fatal. */
RM_DEFINE_ERROR(ERROR_FATAL_INVALID_SECTORS)
/** Requested User Operation not currently allowed. Operation aborted safely. */
RM_DEFINE_ERROR(ERROR_UOP_NOT_ALLOWED)
/** Navigation state machine is not in a state where user commands are allowed.
    Call Schedule a few times and try again later. This is not fatal.
*/
RM_DEFINE_ERROR(ERROR_QUEUE_COMMAND)
/** Either user parameters to the operation were not valid or device data does
    not allow this operation. Operation is thus aborted. This is not fatal.
*/
RM_DEFINE_ERROR(ERROR_NOT_SET)
/** There is no next PGC to jump to. Typically happens when calling
    NextChapter.
*/
RM_DEFINE_ERROR(ERROR_NO_NEXT_PGC)
/** There is no prev PGC to jump to. Typically happens when calling
    PrevChapter.
*/
RM_DEFINE_ERROR(ERROR_NO_PREV_PGC)
/** No still mode. Typically happens if the user requested a Still_Off and
    no still was active.
*/
RM_DEFINE_ERROR(ERROR_NO_STILL)
/** Somehow, device content is not compatible with the current parental level.
    This is a fatal error.
*/
RM_DEFINE_ERROR(ERROR_PARENTAL_CONTROL)
/** Bad Command on the DVD device: This is a Fatal error. It means the DVD
    content is invalid.
*/
RM_DEFINE_ERROR(ERROR_BAD_COMMAND)
/** Could not find the start of VOBU for PGC. This is a Fatal error. */
RM_DEFINE_ERROR(ERROR_NOT_FOUND)
/** No First Play PGC could be found on DVD device. This means it is not
    possible to start playback of the DVD device with user interraction.
*/
RM_DEFINE_ERROR(ERROR_NO_FPPGC)
/** The user located Point A but the DVD navigation reached the end of the current PGC
    before the user could locate point B. Repeat AB playback is thus disabled.
*/
RM_DEFINE_ERROR(ERROR_ENDOFTITLE_REPEATA)
/** The user requested an operation which requires a different playmode than
    the one currently in effect. The different playmodes are:
	- play normal
	- repeat chapter
	- repeat title
	- playlist
	- repeat a (point a has been choosen, but not point b)
	- repeat ab (point a and b have been choosen and repeat ab is in effect)
    The solution if you get this error, is, obviously, to disable the current playmode.
*/
RM_DEFINE_ERROR(ERROR_WRONG_PLAY_MODE)
/** Could not read a navigation pack at a critical moment. This is a fatal error. */
RM_DEFINE_ERROR(ERROR_NAVIGATION_PACK)
/** The user requested a menu which does not exist. */
RM_DEFINE_ERROR(ERROR_NO_SUCH_MENU)
/** Navigation is in a loop. It has nothing to do. */
RM_DEFINE_ERROR(ERROR_NOTHING_TO_DO)
/** DVD Drive is an RPC2 drive and Its region is not set. This is a fatal error. */
RM_DEFINE_ERROR(ERROR_RPC2_NOT_SET)
/** DVD Drive is RPC2 and this is not compatible with the user-preferences. */
RM_DEFINE_ERROR(ERROR_RPC2)
/** DVD Drive region settings, DVD Disc region settings and DVD Navigation region settings
    are not compatible.
*/
RM_DEFINE_ERROR(ERROR_REGION)
/** No disc is present in DVD Drive. This is a fatal error.*/
RM_DEFINE_ERROR(ERROR_NO_DISC_IN_DRIVE)
/** User-provided video mode is not valid. This is a fatal error.*/
RM_DEFINE_ERROR(ERROR_VIDEO_MODE)
/** DVD navigation is already playing data. It cannot complete the operation requested by the user.*/
RM_DEFINE_ERROR(ERROR_PLAYING_ALREADY)
/** DVD navigation is not playing. It cannot complete the operation requested by the user.*/
RM_DEFINE_ERROR(ERROR_NOT_PLAYING)
/** DVD navigation is not constructed. It cannot complete the operation requested by the user.*/
RM_DEFINE_ERROR(ERROR_NOT_CONSTRUCTED)
/** DVD navigation is not paused. It cannot complete the operation requested by the user.*/
RM_DEFINE_ERROR(ERROR_NOT_PAUSING)
//@}


//@{
// PUSH model errors
RM_DEFINE_ERROR(NOBUFFER_AVAILABLE)
//@}
//@{

// streaming errors errors
RM_DEFINE_ERROR(FATAL_COREPOOL_CREATION)
RM_DEFINE_ERROR(FATAL_THREAD_DESTRUCTION)
RM_DEFINE_ERROR(FATAL_THREAD_CREATION)
//@}

//@{
// mambo property set/get api
RM_DEFINE_ERROR(INVALID_BOARD_HANDLE)
RM_DEFINE_ERROR(INVALID_CHIP_HANDLE)
RM_DEFINE_ERROR(INVALID_MODULE_HANDLE)
RM_DEFINE_ERROR(INVALID_PROPERTY_HANDLE)
//@}

//@{
// streaming error
RM_DEFINE_ERROR(WRONGRTSPANSWER)
RM_DEFINE_ERROR(WRONG_RELIABLE_RTP_STATE)
RM_DEFINE_ERROR(ERROR_BUFFER_TO_SMALL)  
RM_DEFINE_ERROR(ERROR_NOT_VOD)  
RM_DEFINE_ERROR(ERROR_STATE)    
RM_DEFINE_ERROR(UNSUPPORTED_SPEED)    
//@}

//@{
// divx drm errors
RM_DEFINE_ERROR(DRM_UNKNOWN_TYPE)
RM_DEFINE_ERROR(DRM_INVALID_KEY)
RM_DEFINE_ERROR(DRM_DECRYPTION_FAILED)
RM_DEFINE_ERROR(DRM_EXPIRED_RENTAL)
RM_DEFINE_ERROR(DRM_UNAUTHORIZED_USER)
RM_DEFINE_ERROR(DRM_INVALID_FILE)
//@}

//@{
// Hardware library errors
/** For instance, microcode is processing a command and cannot accept another */
RM_DEFINE_ERROR(ERROR_COMMAND_PENDING)
/** The application has sent an invalid command */
RM_DEFINE_ERROR(ERROR_INVALID_COMMAND)
/** Internal error: the ucode has returned an invalid or unknown message */
RM_DEFINE_ERROR(ERROR_INVALID_MESSAGE)
//@}

//@{
// dvd audio errors
/** to differenciate audio only player and video capable players */
RM_DEFINE_ERROR(STATE_NOT_SUPPORTED)
/** to deferianciate parameters errors device reader errors */
RM_DEFINE_ERROR(ERROR_PARSER)
//@}

//@{
// vcd errors
/** when the playback reach the end of the disc and other disc have to be inserted in the drive. */
RM_DEFINE_ERROR(INSERT_OTHER_DISC)
//@}

//@{
// remote control errors
/** when the last key pressed can not be interpret */
RM_DEFINE_ERROR(UNKNOWN_KEY)
//@}


//@{
// WMAPROdecoder errors
/** no more data to decode in packet */
RM_DEFINE_ERROR(WMAPRO_NO_MORE_DATA)
RM_DEFINE_ERROR(WMAPRO_SKIPFRAME)
RM_DEFINE_ERROR(WMAPRO_NO_MORE_SAMPLES)
//@}

//@{
// ASF conditions
/** index not available */
RM_DEFINE_ERROR(ASF_WITHOUT_INDEX)
//@}


//@{
// EOS conditions
/** key processed while waiting for EOS */
RM_DEFINE_ERROR(KEY_WHILE_WAITING_EOS)
/** EOS encountered */
RM_DEFINE_ERROR(EOS)
//@}


//@{
// CCFifo errors
/** Attempt to open CCFifo module whereas it is already open */
RM_DEFINE_ERROR(CCFIFO_ALREADY_OPEN)
//@}

RM_DEFINE_ERROR(TIMEOUT)
RM_DEFINE_ERROR(BUSY)

RM_DEFINE_ERROR(SKIP_DATA)


//@{
// NeroDigital DRM errors
/** DRM prevents playback */
RM_DEFINE_ERROR(DRM_PREVENTS_PLAYBACK)
//@}
