/*****************************************
 Copyright © 2001-2003  
 Sigma Designs, Inc. All Rights Reserved
 Proprietary and Confidential
 *****************************************/
/**
  @file   rmlibcw.h
  @brief  

  long description

  @author Emmanuel Michon
  @date   2002-12-06
*/

#ifndef __RMLIBCW_H__
#define __RMLIBCW_H__

#ifdef __GNUC__
/** 
 * NOTE IF YOU THINK THE #include BELOW BREAKS YOUR BUILD:
 * 
 * The problem with using "../.." when including a header file from a different
 * module, is that this assumes that the relative location of the two modules 
 * is known.
 * There are actual cases where that assumption cannot be made. In particular, 
 * all the code in the Curacao package cannot assume where the MRUA code is 
 * located and has to rely on the use of the -I parameter to the compiler to 
 * compile correctly.
 * For the build to compile, consider adding a -I../.. to the RMCFLAGS for that
 * module. If you look at scripts/inc.Makefile, lines 14 to 24 do just that,
 * based on the definition of the 'base_dir' variable, which, you will notice, 
 * is defined in the rmlibcw Makefile.
 *
 * The rest of the #ifdef __GNUC__ is a workaround for the CE platform where, 
 * I am told, engineers cannot freely set -I paramters. This 'hack' WILL
 * DEFINITELY prevent Curacao from building on CE.
 */
#include "rmdef/rmdef.h"
#else
#include "../../rmdef/rmdef.h"
#endif

// we do implement RMDBGLOG_implementation as a function at this level
#undef RMDBGLOG_implementation

#include "rmnonascii.h"

#ifdef WITH_THREADS
#include "rmsemaphores.h"
#include "rmcriticalsections.h"
#include "rmtimeoutsemaphore.h"
#include "rmthreads.h"
#endif // WITH_THREADS

#include "rmrandom.h"
#include "rmtime.h"
#include "rmsprintf.h"
#include "rmfile.h"
#include "rmenv.h"
#include "rmsocket.h"
#include "rmpacketcommandioctl.h"
#include "rmdynamicloader.h"

#endif // __RMLIBCW_H__
