/*****************************************
 Copyright  2001-2005
 Sigma Designs, Inc. All Rights Reserved
 Proprietary and Confidential
 *****************************************/
/**
  @file   cache.h
  @brief  Simple cache for HTTP streaming

  @author Julien Lerouge
  @date   2005-03-02
*/

#ifndef __CACHE_H
#define __CACHE_H

#include "../include/rmlibhttp.h"

struct cache_s;

/**
 * Create a cache of nbuffer*buffersize bytes
 * @param nbuffer (must be <= 32)
 * @param buffersize
 * @return struct cache_s *, NULL on error
 **/
struct cache_s * init_cache(RMint32 nbuffer, RMuint32 buffersize);


/**
 * Try to chunk of data starting at address start from the cache
 * @param struct cache_s *cache
 * @param start - start address of the chunk
 * @param void **buffer - buffer is returned here
 * @return < 0 on a miss, > 0 on a hit
 */
RMint32 get_buffer_cache(struct cache_s *cache, RMuint32 start, RMuint8 **buffer);

/**
 * Destroy a cache 
 * @param struct cache_s *cache
 */
void destroy_cache(struct cache_s *cache);


#endif //__CACHE_H
