/*
 *--------------------------------------------------------------------
 *
 * COPYRIGHT (c)  2002-2004  INTEL CORPORATION.      ALL  RIGHTS 
 * RESERVED.  THIS  PROGRAM IS  FURNISHED  UNDER  LICENSE  AND MAY
 * ONLY BE USED OR  COPIED IN  ACCORDANCE WITH  THE  TERMS OF THAT 
 * LICENSE.  NO  PART  OF THIS  PROGRAM  OR  PUBLICATION  MAY  BE
 * REPRODUCED,  TRANSMITTED,  TRANSCRIBED,  STORED IN  A RETRIEVAL 
 * SYSTEM, OR  TRANSLATED INTO ANY  LANGUAGE OR COMPUTER  LANGUAGE 
 * IN ANY FORM OR BY  ANY MEANS, ELECTRONIC, MECHANICAL, MAGNETIC,
 * OPTICAL,  CHEMICAL, MANUAL, OR  OTHERWISE,  WITHOUT  THE  PRIOR 
 * WRITTEN PERMISSION OF INTEL  CORPORATION.  EXCEPT AS  EXPRESSLY
 * GRANTED IN A LICENSE AGREEMENT, THIS PROGRAM IS FURNISHED "AS-IS"
 * WITH NO WARRANTY WHATSOEVER, INCLUDING IMPLIED WARRANTIES OF
 * MERCHANTABILITY,  FITNESS FOR A  PARTICULAR PURPOSE,   AND NON-
 * INFRINGEMENT.    
 *           
 *--------------------------------------------------------------------
 *     File Name: CommandLineShell.h
 *     Author:    Intel Corporation
 *
 */

#ifndef COMMAND_LINE_SHELL_H
#define COMMAND_LINE_SHELL_H

/* The control point is held by the shell */

// ***************************************************************
// Updated by Ronggang Yu (ronggang.yu@intel.com)
// #include "MmsCP.h"
   #include "MmsCp.h"
// ***************************************************************

#include "MSCP_ControlPoint.h"


/*
 * Call this to setup the shell.  Note that this is the call that
 * will start the control points, and the thread will be relinquished quickly.
 *
 * This will not, however, start the shell.  To start the shell, call STBS_Run.
 */
void CLShell_Init(void *chain);

/*
 * The main shell event loop.  Note that this will not relinquish the thread
 * until the shell exits, symbolizing that the user desires to quit.
 */
int CLShell_Run(void);

/*
 * Shut down the control points and clean up memory allocation.
 */
void CLShell_Uninit(void);

#endif

