/*
 *
 * Copyright (c) Sigma Designs, Inc. 2005. All rights reserved.
 *
 */
#ifndef __MS_UPNP_TYPES_H_
#define __MS_UPNP_TYPES_H_

#include "wmdrmndcoreapi.h"
#include "../include/ms_upnp.h"

#define MS_DRM_CONTEXT(device) (MS_UPNP((device))->drm_context)

#define MAX_MS_STREAM 128

/** Maximum number of UPnP device we can have at the same time */
#define MAX_MS_DEVICE 64

struct ms_stream_decryption_context_s {
	/* Current Media object number */
	RMuint32 media_object_number;
	/* Byte count for this stream, per media object (reset for each new media object) */
	RMuint32 byte_count;
	/* Current sample ID */
	RMuint8 sample_id[8];
};

struct ms_upnp_extension_s {
	/* Flags to store the current state with a given media server */
	RMuint32 flags;
	/* DRM context */
	wmdrmnet_context *drm_context;
	/* Arbitrary string passed to the DMR with the License Response message */
	RMascii *session_header;
	/* The current URL associated with the session header and DRM context */
	RMascii *url;
	/* Stream decryption contexts */
	struct ms_stream_decryption_context_s ms_stream_decryption_context[MAX_MS_STREAM];
	
};

#endif /* __MS_UPNP_TYPES_H_ */
