/*
 * INTEL CONFIDENTIAL
 * Copyright (c) 2002, 2003 Intel Corporation.  All rights reserved.
 * 
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel
 * Corporation or its suppliers or licensors.  Title to the
 * Material remains with Intel Corporation or its suppliers and
 * licensors.  The Material contains trade secrets and proprietary
 * and confidential information of Intel or its suppliers and
 * licensors. The Material is protected by worldwide copyright and
 * trade secret laws and treaty provisions.  No part of the Material
 * may be used, copied, reproduced, modified, published, uploaded,
 * posted, transmitted, distributed, or disclosed in any way without
 * Intel's prior express written permission.
 
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you
 * by disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel or otherwise. Any license
 * under such intellectual property rights must be express and
 * approved by Intel in writing.
 * 
 * $Workfile: MSCP_ControlPoint.h
 * $Revision: #1.0.1799.42459
 * $Author:   Intel Corporation, Intel Device Builder
 * $Date:     Monday, March 21, 2005
 *
 *
 *
 */
#ifndef __MSCP_ControlPoint__
#define __MSCP_ControlPoint__

#include "UPnPControlPointStructs.h"

#define X_DLNADOC "X_DLNADOC"
#define X_DLNADOC_NAMESPACE "urn:schemas-dlna-org:device-1-0"

char *MSCP_GetCustomXML_X_DLNADOC(struct UPnPDevice *d);


/* Complex Type Parsers */


/* Complex Type Serializers */



void MSCP_AddRef(struct UPnPDevice *device);
void MSCP_Release(struct UPnPDevice *device);

struct UPnPDevice* MSCP_GetDevice1(struct UPnPDevice *device,int index);
int MSCP_GetDeviceCount(struct UPnPDevice *device);
struct UPnPDevice* MSCP_GetDeviceAtUDN(void *v_CP,char* UDN);

void PrintUPnPDevice(int indents, struct UPnPDevice *device);


char *MSCP_GetCustomTagFromDevice(struct UPnPDevice *d, char* FullNameSpace, char* Name);


void *MSCP_CreateControlPoint(void *Chain, void(*A)(struct UPnPDevice*),void(*R)(struct UPnPDevice*));
void MSCP__CP_IPAddressListChanged(void *CPToken);
struct UPnPDevice* MSCP_GetDeviceEx(struct UPnPDevice *device, char* DeviceType, int start,int number);
int MSCP_HasAction(struct UPnPService *s, char* action);
void MSCP_UnSubscribeUPnPEvents(struct UPnPService *service);
void MSCP_SubscribeForUPnPEvents(struct UPnPService *service, void(*callbackPtr)(struct UPnPService* service,int OK));
struct UPnPService *MSCP_GetService(struct UPnPDevice *device, char* ServiceName, int length);

struct UPnPService *MSCP_GetService_ContentDirectory(struct UPnPDevice *device);
struct UPnPService *MSCP_GetService_Registrar(struct UPnPDevice *device);


extern void (*MSCP_EventCallback_ContentDirectory_ContainerUpdateIDs)(struct UPnPService* Service,char* ContainerUpdateIDs);
extern void (*MSCP_EventCallback_ContentDirectory_SystemUpdateID)(struct UPnPService* Service,unsigned int SystemUpdateID);
extern void (*MSCP_EventCallback_ContentDirectory_TransferIDs)(struct UPnPService* Service,char* TransferIDs);
extern void (*MSCP_EventCallback_Registrar_AuthorizationDeniedUpdateID)(struct UPnPService* Service,unsigned int AuthorizationDeniedUpdateID);
extern void (*MSCP_EventCallback_Registrar_ValidationSucceededUpdateID)(struct UPnPService* Service,unsigned int ValidationSucceededUpdateID);
extern void (*MSCP_EventCallback_Registrar_ValidationRevokedUpdateID)(struct UPnPService* Service,unsigned int ValidationRevokedUpdateID);
extern void (*MSCP_EventCallback_Registrar_AuthorizationGrantedUpdateID)(struct UPnPService* Service,unsigned int AuthorizationGrantedUpdateID);


void MSCP_Invoke_ContentDirectory_Browse(struct UPnPService *service, void (*CallbackPtr)(struct UPnPService*,int ErrorCode,void *user,char* Result,unsigned int NumberReturned,unsigned int TotalMatches,unsigned int UpdateID),void* _user, char* ObjectID, char* BrowseFlag, char* Filter, unsigned int StartingIndex, unsigned int RequestedCount, char* SortCriteria);
void MSCP_Invoke_ContentDirectory_GetSearchCapabilities(struct UPnPService *service, void (*CallbackPtr)(struct UPnPService*,int ErrorCode,void *user,char* SearchCaps),void* _user);
void MSCP_Invoke_ContentDirectory_GetSortCapabilities(struct UPnPService *service, void (*CallbackPtr)(struct UPnPService*,int ErrorCode,void *user,char* SortCaps),void* _user);
void MSCP_Invoke_ContentDirectory_GetSystemUpdateID(struct UPnPService *service, void (*CallbackPtr)(struct UPnPService*,int ErrorCode,void *user,unsigned int Id),void* _user);
void MSCP_Invoke_Registrar_IsAuthorized(struct UPnPService *service, void (*CallbackPtr)(struct UPnPService*,int ErrorCode,void *user,int Result),void* _user, char* DeviceID);
void MSCP_Invoke_Registrar_IsValidated(struct UPnPService *service, void (*CallbackPtr)(struct UPnPService*,int ErrorCode,void *user,int Result),void* _user, char* DeviceID);
void MSCP_Invoke_Registrar_RegisterDevice(struct UPnPService *service, void (*CallbackPtr)(struct UPnPService*,int ErrorCode,void *user,unsigned char* RegistrationRespMsg,int RegistrationRespMsgLength),void* _user, unsigned char* RegistrationReqMsg, int RegistrationReqMsgLength);


#endif
